pipeline {
    agent any
    
    stages {
        stage('Notify GitLab') {
          steps {
                echo 'Notify GitLab - Pending'
                updateGitlabCommitStatus name: 'jenkins-tests', state: 'pending'
            }
        }
        stage('Install Dependencies') {
            steps {
                sh 'python3 -m venv venv'
                sh '. venv/bin/activate'
                sh 'pip install -r requirements.txt'
            }
        }
        stage('Lint with Black') {
            steps {
                sh '. venv/bin/activate'
                sh 'black .'
            }
        }
        stage('Run Tests with Pytest') {
            steps {
                sh '. venv/bin/activate'
                sh 'pytest -v'
            }
        }
    }
    post {
        failure {
            discordSend description: "Build failed (#${env.BUILD_NUMBER}). Please check the logs for details.", 
                        footer: "Discord Notifier (Jenkins Plugin)",
                        link: env.BUILD_URL, 
                        result: currentBuild.currentResult, 
                        title: env.JOB_NAME,
                        webhookURL: "https://canary.discord.com/api/webhooks/1085239737616445520/wxFyFSbCNRysPlc_KxYAADRW8iNda3IXQZsNg0jof6uEp95qKfm6Wj_wjR3JxLtpAz8o"
            updateGitlabCommitStatus name: 'jenkins-tests', state: 'failed'
        }
        success {
            updateGitlabCommitStatus name: 'jenkins-tests', state: 'success'
        }

    }
}
